//require base/meta.js
//require base/Widget.js

(function($){
    
var earlyFns = [];
var earlyFnCount = 0;
var initFns = [];
var initFnCount = 0;

function init()
{
    if (opensaga.canDo())
    {
//        console.debug("OpenSAGA init: earlyFns = %o, initFns = %o", earlyFns, initFns);
        var i=0; 
        for (var i=0; i < earlyFnCount; i++)
        {
            earlyFns[i].call(window);
        }
        
        opensaga.$page = $("#page");
    
        var meta = opensaga.getPageMetaData();                             
        Widget.createWidgets(null, meta ? meta.widgets : null);
        
        if (opensaga.scaleLayout)
        {
            opensaga.scaleLayout(meta,null);
        }
        
        for (var i=0; i < initFnCount; i++)
        {
            initFns[i].call(window);
        }
    }
    
    opensaga.initiallyEnhanced = true;
}

var canDo = null;

this.opensaga = {
getPageMetaData: meta.getPageMetaData,
decoration: meta.decoration,
canDo:
    function()
    {
        if (canDo === null)
        {
            canDo = jQuery.ajaxSettings.xhr() && document.createElement && document.getElementById; 
        }
        return canDo;
    },
ready:
    function(fn)
    {
        if (opensaga.initiallyEnhanced)
        {
            if (opensaga.canDo())
            {
                fn.call(window);
            }
        }
        else
        {
            initFns[initFnCount++] = fn;
        }
    },
addEarly:
    function(fn)
    {
        earlyFns[earlyFnCount++] = fn;
    },   
url:
    function(url, params)
    {
       var divider=url.indexOf("?") < 0 ? "?" : "&";
       for ( key in params)
       {
         url = url + divider + escape(key) + "=" + escape(params[key]);
         divider="&";
       }
       return url;
    },
/**
Inspired by ( http://www.quirksmode.org/blog/archives/2006/01/contains_for_mo.html )
*/
contains:
    function (a, b)
    {
        return a.compareDocumentPosition ?
            !!(a.compareDocumentPosition(b) & 16):
            (a.contains ? a.contains(b) : true) ;
    }
};

var match = /^(http|https):\/\/[^\/]*(\/.*)?\/app\/.*$/.exec(location);
if (match)
{
    opensaga.contextPath = match[2] || "";
}
else
{
    console.error("Couldn't determine context path.");
}

opensaga.$window = $(window);
opensaga.$document = $(document);

$(init);

})(jQuery);

ScriptLoader.signalLoaded("base/opensaga-init.js");
